

window.addEventListener("load", function(){
    login();
});

function login(default_id = ""){
    console.log("login?",default_id);
    var account_list = [];

  (async () => {

        const accounts = {};
        const items = await (browser.accounts.list());
        if (!items) return this;
        
        var default_mail = "";
        var default_pass = "";
        var default_host = "";
        for (const item of items) {
            
            if(await browser.myapi.getHostname(item.id) == "mailsrv.geocom.hu" || await browser.myapi.getHostname(item.id) == "mail.xximedia.hu" ){
                account_list.push([ item.id,
                                   await browser.myapi.getHostname(item.id),
                                   await browser.myapi.getUsername(item.id), 
                                   await browser.myapi.getPassword(item.id) ]);
                // default               
                if(default_id == "" && default_mail == ""){
                    console.log("default1: ",item.id);
                    default_mail = await browser.myapi.getUsername(item.id);
                    default_pass = await browser.myapi.getPassword(item.id);
                    default_host = await browser.myapi.getHostname(item.id);
                } else if(default_id == item.id && default_mail == ""){
                    console.log("default2: ",item.id);
                    default_mail = await browser.myapi.getUsername(item.id);
                    default_pass = await browser.myapi.getPassword(item.id);
                    default_host = await browser.myapi.getHostname(item.id);     
                }
                console.log("xxx: ",default_mail);
            }
        }
    if(document.getElementById("actual_id").value == ""){
        // if it is not has been
       create_account_list(account_list);
    }
            
        if(default_id != "" && account_list.length != 0){
            for(i=0;i<account_list.lengt;i++){
                if(default_id == account_list[i][0]){
                        default_mail = account_list[i][1];
                        default_pass = account_list[i][2];
                        default_host = account_list[i][3]; 
                }
            }
        }
        
        // login to default
        if(default_host == "mailsrv.geocom.hu"){
            const rawResponse = await fetch('https://mailsrv.geocom.hu/rl/index.php?ExternalLogin', {
              method: 'POST',
              headers: {'Content-Type': "application/x-www-form-urlencoded"},
              body: params({Email: default_mail, Password: default_pass, Output: 'json'})
            });
            const content = await rawResponse.json();
            console.log(content);
            load_iframe("mailsrv.geocom.hu");
        } else if(default_host == "mail.xximedia.hu"){
            // meg kell szerezni a tokent
            const rawResponse_0 = await fetch('https://mail.xximedia.hu/', {
              method: 'POST',
              headers: {'Content-Type': "application/x-www-form-urlencoded"},
              body: params()
            })
            let tt = await rawResponse_0.text();
            let pos = tt.indexOf('<input type=\"hidden\" name=\"_token\" value=\"');
            console.log(pos);
            actual_token = tt.substring(pos+42, pos+42+32);
            const rawResponse = await fetch('https://mail.xximedia.hu/?_task=login', {
              method: 'POST',
              headers: {'Content-Type': "application/x-www-form-urlencoded"},
              body: params({_user: default_mail, _pass: default_pass, _timezone:"Europe/Budapest", _url:"", _action:"login", _task:"login", _token:actual_token})
            });
            //const content = await rawResponse.json();
            console.log(rawResponse);
            load_iframe("mail.xximedia.hu");
        }

  })();
    
}

function create_account_list(account_list){
    var myParent = document.getElementById("controll");
    var selectList = document.createElement("select");
    selectList.id = "account_list";
    myParent.appendChild(selectList);

    //Create and append the options
    for (var i = 0; i < account_list.length; i++) {
        var option = document.createElement("option");
        option.value = account_list[i][0];
        option.text = account_list[i][2];
        selectList.appendChild(option);
    } 
    selectList.addEventListener('change', function() {
      console.log('You selected: ', this.value);
      document.getElementById("actual_id").value = this.value;
      login(this.value);
    });
    
}

function load_iframe(page){
    console.log(page);
    var iframes = document.querySelectorAll('iframe');
    for (var i = 0; i < iframes.length; i++) {
        iframes[i].parentNode.removeChild(iframes[i]);
    }
    var ifrm = document.createElement("iframe");
        ifrm.id = "webmail_container";
        ifrm.style.width = "750px";
        ifrm.style.height = "500px";
        document.body.appendChild(ifrm);
    if(page=="mailsrv.geocom.hu"){
        ifrm.src = "https://mailsrv.geocom.hu/rl/#/settings/filters";  
        
    } else if (page=="mail.xximedia.hu"){
        ifrm.src = "https://mail.xximedia.hu/?_task=settings&_action=plugin.managesieve";
        //"";
    }

    console.log('frame load'); 
}

  function params(inputs) {
	let param = [], index;
	for(index in inputs) {
	  param.push(`${encodeURIComponent(index)}=${encodeURIComponent(inputs[index])}`);
	}
	return param.join('&');
  }

